#ifndef _HOOKING_H_
#define _HOOKING_H_

#include <Windows.h>
#include "DriverAccess.h"

extern "C" void __stdcall CALLSTUB1(void);
extern "C" void __stdcall CALLSTUB2(void);
extern "C" void __stdcall MYJMP(void);
extern "C" void __stdcall ORIGINALCODE(void);
extern "C" int  __stdcall GetInstructionLength_x64(void *InPtr, int InType);

#define CODE_PATCH_LIMIT 100

typedef struct
{
	BYTE	OriginalCode[256];
	BYTE	CallStub[256];
	LPVOID  APIAddr;
	LPVOID  IPCBufferIn;
	LPVOID  IPCBufferOut;
	LPVOID  IPCFunc_Write;
	LPVOID  wsprintfW_ptr;
	LPVOID  WriteFile_ptr;
	HANDLE  hFile;
} HOOKSTRUCT, *PHOOKSTRUCT;

typedef struct
{
	LPVOID	lpBufIN;
	LPVOID  lpBufOUT;
} IPC_PARAMS, *PIPC_PARAMS;

LPVOID	GetAPIAddress(LPWSTR pwszLibName, LPSTR pszFunctionName);
BOOL	HookDLLFunction(LPTSTR lpDllName,
						LPSTR lpFuncName,
						BYTE *hook_add,
						DWORD hook_len,
						BYTE *data_add,
						DWORD dwDataLen,
						DWORD dwArgsNum);

int ModAsmCode(PBYTE pbOutCode, PBYTE lpCode);
int ParseAsmCode(char* lpCode);

//api pointers

typedef HANDLE	(WINAPI *CreateFileW_ptr)				(LPCWSTR lpFileName, DWORD dwDesiredAccess, DWORD dwShareMode, LPSECURITY_ATTRIBUTES lpSecurityAttributes, DWORD dwCreationDisposition, DWORD dwFlagsAndAttributes, HANDLE hTemplateFile);
typedef BOOL	(WINAPI *DeleteFileW_ptr)				(LPCWSTR lpFileName);
typedef INT		(WINAPI *DispatchMessageW_ptr)			(CONST MSG *lpMsg);
typedef BOOL	(WINAPI *GetMessageW_ptr)				(LPMSG lpMsg, HWND hWnd, UINT wMsgFilterMin, UINT wMsgFilterMax, UINT wRemoveMsg);
typedef BOOL	(WINAPI *MoveFileW_ptr)					(LPCWSTR lpOldFile, LPCWSTR lpNewFile);
typedef NTSTATUS(*NtEnumerateValueKey_ptr)				(HANDLE KeyHandle, ULONG Index, KEY_VALUE_INFORMATION_CLASS KeyValueInformationClass, PVOID KeyValueInformation, ULONG Length, PULONG ResultLength);
typedef NTSTATUS(*NtQueryDirectoryFile_ptr)				(HANDLE FileHandle, HANDLE Event, LPVOID ApcRoutine, PVOID ApcContext, PIO_STATUS_BLOCK IoStatusBlock, PVOID FileInformation, ULONG Length, FILE_INFORMATION_CLASS FileInformationClass, BOOLEAN ReturnSingleEntry, PUNICODE_STRING FileName, BOOLEAN RestartScan);
typedef NTSTATUS(*NtQueryKey_ptr)						(HANDLE KeyHandle, KEY_INFORMATION_CLASS KeyInformationClass, PVOID KeyInformation, ULONG Length, PULONG ResultLength);
typedef NTSTATUS(WINAPI *NtQuerySystemInformation_ptr)	(PROCESSINFOCLASS SystemInformationClass, PVOID SystemInformation, ULONG SystemInformationLength, PULONG ReturnLength);
typedef BOOL	(WINAPI *PeekMessageW_ptr)				(LPMSG lpMsg, HWND hWnd, UINT wMsgFilterMin, UINT wMsgFilterMax, UINT wRemoveMsg);


//hook functions prototypes

HANDLE WINAPI H_CreateFileW(LPVOID data_param,
							LPCWSTR lpFileName,
							DWORD dwDesiredAccess,
							DWORD dwShareMode,
							LPSECURITY_ATTRIBUTES lpSecurityAttributes,
							DWORD dwCreationDisposition,
							DWORD dwFlagsAndAttributes,
							HANDLE hTemplateFile);

BOOL	WINAPI	H_DeleteFileW(LPVOID data_param, LPCWSTR lpFileName);
LRESULT	WINAPI	H_DispatchMessageW(LPVOID data_param, const MSG* msg);
NTSTATUS H_NtEnumerateValueKey(LPVOID data_param, HANDLE KeyHandle, ULONG Index, KEY_VALUE_INFORMATION_CLASS KeyValueInformationClass, PVOID KeyValueInformation, ULONG Length, PULONG ResultLength);
BOOL WINAPI H_GetMessageW(LPVOID data_param, LPMSG lpMsg, HWND hWnd, UINT wMsgFilterMin, UINT wMsgFilterMax, UINT wRemoveMsg);
BOOL WINAPI H_MoveFileW(LPVOID data_param, LPCWSTR lpOldFile, LPCWSTR lpNewFile);
NTSTATUS H_NtQueryKey(LPVOID data_param, HANDLE KeyHandle, KEY_INFORMATION_CLASS KeyInformationClass, PVOID KeyInformation, ULONG Length, PULONG ResultLength);
NTSTATUS H_NtQuerySystemInformation(LPVOID data_param, PROCESSINFOCLASS SystemInformationClass, PVOID SystemInformation, ULONG SystemInformationLength, PULONG ReturnLength);
BOOL WINAPI H_PeekMessageW(LPVOID data_param, LPMSG lpMsg, HWND hWnd, UINT wMsgFilterMin, UINT wMsgFilterMax, UINT wRemoveMsg);
NTSTATUS H_NtQueryDirectoryFile(LPVOID data_param, HANDLE FileHandle, HANDLE Event, LPVOID ApcRoutine, PVOID ApcContext, PIO_STATUS_BLOCK IoStatusBlock, PVOID FileInformation, ULONG Length, FILE_INFORMATION_CLASS FileInformationClass, BOOLEAN ReturnSingleEntry, PUNICODE_STRING FileName, BOOLEAN RestartScan);

#endif